//where piece[0][x][y][rotation] = 0 (no piece there), 1 - 7 (stationary color piece), or 8 (falling current piece);

extern int			piece[7][4][4][4], grid[10][17], gridBackup[10][17];
extern unsigned long	colors[7];


void	nullBoard( void )
{
	int	x, y;
	for( x=0; x<10; x++ ) {
		for( y=0; y<17; y++ ) {
			grid[x][y] = 0;
		}
	}
}

void	nullBoardBackup( void )
{
	int	x, y;
	for( x=0; x<10; x++ ) {
		for( y=0; y<17; y++ ) {
			gridBackup[x][y] = 0;
		}
	}
}

void	createPieces( void )
{
	//Piece 1
	
	piece[0][0][0][0] = 0;
	piece[0][1][0][0] = 1;
	piece[0][2][0][0] = 1;
	piece[0][3][0][0] = 0;
	piece[0][0][1][0] = 0;
	piece[0][1][1][0] = 1;
	piece[0][2][1][0] = 1;
	piece[0][3][1][0] = 0;
	piece[0][0][2][0] = 0;
	piece[0][1][2][0] = 0;
	piece[0][2][2][0] = 0;
	piece[0][3][2][0] = 0;
	piece[0][0][3][0] = 0;
	piece[0][1][3][0] = 0;
	piece[0][2][3][0] = 0;
	piece[0][3][3][0] = 0;

	piece[0][0][0][1] = 0;
	piece[0][1][0][1] = 1;
	piece[0][2][0][1] = 1;
	piece[0][3][0][1] = 0;
	piece[0][0][1][1] = 0;
	piece[0][1][1][1] = 1;
	piece[0][2][1][1] = 1;
	piece[0][3][1][1] = 0;
	piece[0][0][2][1] = 0;
	piece[0][1][2][1] = 0;
	piece[0][2][2][1] = 0;
	piece[0][3][2][1] = 0;
	piece[0][0][3][1] = 0;
	piece[0][1][3][1] = 0;
	piece[0][2][3][1] = 0;
	piece[0][3][3][1] = 0;

	piece[0][0][0][2] = 0;
	piece[0][1][0][2] = 1;
	piece[0][2][0][2] = 1;
	piece[0][3][0][2] = 0;
	piece[0][0][1][2] = 0;
	piece[0][1][1][2] = 1;
	piece[0][2][1][2] = 1;
	piece[0][3][1][2] = 0;
	piece[0][0][2][2] = 0;
	piece[0][1][2][2] = 0;
	piece[0][2][2][2] = 0;
	piece[0][3][2][2] = 0;
	piece[0][0][3][2] = 0;
	piece[0][1][3][2] = 0;
	piece[0][2][3][2] = 0;
	piece[0][3][3][2] = 0;

	piece[0][0][0][3] = 0;
	piece[0][1][0][3] = 1;
	piece[0][2][0][3] = 1;
	piece[0][3][0][3] = 0;
	piece[0][0][1][3] = 0;
	piece[0][1][1][3] = 1;
	piece[0][2][1][3] = 1;
	piece[0][3][1][3] = 0;
	piece[0][0][2][3] = 0;
	piece[0][1][2][3] = 0;
	piece[0][2][2][3] = 0;
	piece[0][3][2][3] = 0;
	piece[0][0][3][3] = 0;
	piece[0][1][3][3] = 0;
	piece[0][2][3][3] = 0;
	piece[0][3][3][3] = 0;



	//Piece 2

	piece[1][0][0][0] = 0;
	piece[1][1][0][0] = 1;
	piece[1][2][0][0] = 0;
	piece[1][3][0][0] = 0;
	piece[1][0][1][0] = 0;
	piece[1][1][1][0] = 1;
	piece[1][2][1][0] = 0;
	piece[1][3][1][0] = 0;
	piece[1][0][2][0] = 0;
	piece[1][1][2][0] = 1;
	piece[1][2][2][0] = 0;
	piece[1][3][2][0] = 0;
	piece[1][0][3][0] = 0;
	piece[1][1][3][0] = 1;
	piece[1][2][3][0] = 0;
	piece[1][3][3][0] = 0;

	piece[1][0][0][1] = 0;
	piece[1][1][0][1] = 0;
	piece[1][2][0][1] = 0;
	piece[1][3][0][1] = 0;
	piece[1][0][1][1] = 1;
	piece[1][1][1][1] = 1;
	piece[1][2][1][1] = 1;
	piece[1][3][1][1] = 1;
	piece[1][0][2][1] = 0;
	piece[1][1][2][1] = 0;
	piece[1][2][2][1] = 0;
	piece[1][3][2][1] = 0;
	piece[1][0][3][1] = 0;
	piece[1][1][3][1] = 0;
	piece[1][2][3][1] = 0;
	piece[1][3][3][1] = 0;

	piece[1][0][0][2] = 0;
	piece[1][1][0][2] = 1;
	piece[1][2][0][2] = 0;
	piece[1][3][0][2] = 0;
	piece[1][0][1][2] = 0;
	piece[1][1][1][2] = 1;
	piece[1][2][1][2] = 0;
	piece[1][3][1][2] = 0;
	piece[1][0][2][2] = 0;
	piece[1][1][2][2] = 1;
	piece[1][2][2][2] = 0;
	piece[1][3][2][2] = 0;
	piece[1][0][3][2] = 0;
	piece[1][1][3][2] = 1;
	piece[1][2][3][2] = 0;
	piece[1][3][3][2] = 0;

	piece[1][0][0][3] = 0;
	piece[1][1][0][3] = 0;
	piece[1][2][0][3] = 0;
	piece[1][3][0][3] = 0;
	piece[1][0][1][3] = 1;
	piece[1][1][1][3] = 1;
	piece[1][2][1][3] = 1;
	piece[1][3][1][3] = 1;
	piece[1][0][2][3] = 0;
	piece[1][1][2][3] = 0;
	piece[1][2][2][3] = 0;
	piece[1][3][2][3] = 0;
	piece[1][0][3][3] = 0;
	piece[1][1][3][3] = 0;
	piece[1][2][3][3] = 0;
	piece[1][3][3][3] = 0;



	//Piece 3

	piece[2][0][0][0] = 0;
	piece[2][1][0][0] = 1;
	piece[2][2][0][0] = 1;
	piece[2][3][0][0] = 0;
	piece[2][0][1][0] = 1;
	piece[2][1][1][0] = 1;
	piece[2][2][1][0] = 0;
	piece[2][3][1][0] = 0;
	piece[2][0][2][0] = 0;
	piece[2][1][2][0] = 0;
	piece[2][2][2][0] = 0;
	piece[2][3][2][0] = 0;
	piece[2][0][3][0] = 0;
	piece[2][1][3][0] = 0;
	piece[2][2][3][0] = 0;
	piece[2][3][3][0] = 0;

	piece[2][0][0][1] = 1;
	piece[2][1][0][1] = 0;
	piece[2][2][0][1] = 0;
	piece[2][3][0][1] = 0;
	piece[2][0][1][1] = 1;
	piece[2][1][1][1] = 1;
	piece[2][2][1][1] = 0;
	piece[2][3][1][1] = 0;
	piece[2][0][2][1] = 0;
	piece[2][1][2][1] = 1;
	piece[2][2][2][1] = 0;
	piece[2][3][2][1] = 0;
	piece[2][0][3][1] = 0;
	piece[2][1][3][1] = 0;
	piece[2][2][3][1] = 0;
	piece[2][3][3][1] = 0;

	piece[2][0][0][2] = 0;
	piece[2][1][0][2] = 1;
	piece[2][2][0][2] = 1;
	piece[2][3][0][2] = 0;
	piece[2][0][1][2] = 1;
	piece[2][1][1][2] = 1;
	piece[2][2][1][2] = 0;
	piece[2][3][1][2] = 0;
	piece[2][0][2][2] = 0;
	piece[2][1][2][2] = 0;
	piece[2][2][2][2] = 0;
	piece[2][3][2][2] = 0;
	piece[2][0][3][2] = 0;
	piece[2][1][3][2] = 0;
	piece[2][2][3][2] = 0;
	piece[2][3][3][2] = 0;

	piece[2][0][0][3] = 1;
	piece[2][1][0][3] = 0;
	piece[2][2][0][3] = 0;
	piece[2][3][0][3] = 0;
	piece[2][0][1][3] = 1;
	piece[2][1][1][3] = 1;
	piece[2][2][1][3] = 0;
	piece[2][3][1][3] = 0;
	piece[2][0][2][3] = 0;
	piece[2][1][2][3] = 1;
	piece[2][2][2][3] = 0;
	piece[2][3][2][3] = 0;
	piece[2][0][3][3] = 0;
	piece[2][1][3][3] = 0;
	piece[2][2][3][3] = 0;
	piece[2][3][3][3] = 0;


	
	//Piece 4

	piece[3][0][0][0] = 1;
	piece[3][1][0][0] = 1;
	piece[3][2][0][0] = 0;
	piece[3][3][0][0] = 0;
	piece[3][0][1][0] = 0;
	piece[3][1][1][0] = 1;
	piece[3][2][1][0] = 1;
	piece[3][3][1][0] = 0;
	piece[3][0][2][0] = 0;
	piece[3][1][2][0] = 0;
	piece[3][2][2][0] = 0;
	piece[3][3][2][0] = 0;
	piece[3][0][3][0] = 0;
	piece[3][1][3][0] = 0;
	piece[3][2][3][0] = 0;
	piece[3][3][3][0] = 0;

	piece[3][0][0][1] = 0;
	piece[3][1][0][1] = 1;
	piece[3][2][0][1] = 0;
	piece[3][3][0][1] = 0;
	piece[3][0][1][1] = 1;
	piece[3][1][1][1] = 1;
	piece[3][2][1][1] = 0;
	piece[3][3][1][1] = 0;
	piece[3][0][2][1] = 1;
	piece[3][1][2][1] = 0;
	piece[3][2][2][1] = 0;
	piece[3][3][2][1] = 0;
	piece[3][0][3][1] = 0;
	piece[3][1][3][1] = 0;
	piece[3][2][3][1] = 0;
	piece[3][3][3][1] = 0;

	piece[3][0][0][2] = 1;
	piece[3][1][0][2] = 1;
	piece[3][2][0][2] = 0;
	piece[3][3][0][2] = 0;
	piece[3][0][1][2] = 0;
	piece[3][1][1][2] = 1;
	piece[3][2][1][2] = 1;
	piece[3][3][1][2] = 0;
	piece[3][0][2][2] = 0;
	piece[3][1][2][2] = 0;
	piece[3][2][2][2] = 0;
	piece[3][3][2][2] = 0;
	piece[3][0][3][2] = 0;
	piece[3][1][3][2] = 0;
	piece[3][2][3][2] = 0;
	piece[3][3][3][2] = 0;

	piece[3][0][0][3] = 0;
	piece[3][1][0][3] = 1;
	piece[3][2][0][3] = 0;
	piece[3][3][0][3] = 0;
	piece[3][0][1][3] = 1;
	piece[3][1][1][3] = 1;
	piece[3][2][1][3] = 0;
	piece[3][3][1][3] = 0;
	piece[3][0][2][3] = 1;
	piece[3][1][2][3] = 0;
	piece[3][2][2][3] = 0;
	piece[3][3][2][3] = 0;
	piece[3][0][3][3] = 0;
	piece[3][1][3][3] = 0;
	piece[3][2][3][3] = 0;
	piece[3][3][3][3] = 0;



	//Piece 5

	piece[4][0][0][0] = 1;
	piece[4][1][0][0] = 1;
	piece[4][2][0][0] = 0;
	piece[4][3][0][0] = 0;
	piece[4][0][1][0] = 0;
	piece[4][1][1][0] = 1;
	piece[4][2][1][0] = 0;
	piece[4][3][1][0] = 0;
	piece[4][0][2][0] = 0;
	piece[4][1][2][0] = 1;
	piece[4][2][2][0] = 0;
	piece[4][3][2][0] = 0;
	piece[4][0][3][0] = 0;
	piece[4][1][3][0] = 0;
	piece[4][2][3][0] = 0;
	piece[4][3][3][0] = 0;

	piece[4][0][0][1] = 0;
	piece[4][1][0][1] = 0;
	piece[4][2][0][1] = 0;
	piece[4][3][0][1] = 0;
	piece[4][0][1][1] = 1;
	piece[4][1][1][1] = 1;
	piece[4][2][1][1] = 1;
	piece[4][3][1][1] = 0;
	piece[4][0][2][1] = 1;
	piece[4][1][2][1] = 0;
	piece[4][2][2][1] = 0;
	piece[4][3][2][1] = 0;
	piece[4][0][3][1] = 0;
	piece[4][1][3][1] = 0;
	piece[4][2][3][1] = 0;
	piece[4][3][3][1] = 0;

	piece[4][0][0][2] = 0;
	piece[4][1][0][2] = 1;
	piece[4][2][0][2] = 0;
	piece[4][3][0][2] = 0;
	piece[4][0][1][2] = 0;
	piece[4][1][1][2] = 1;
	piece[4][2][1][2] = 0;
	piece[4][3][1][2] = 0;
	piece[4][0][2][2] = 0;
	piece[4][1][2][2] = 1;
	piece[4][2][2][2] = 1;
	piece[4][3][2][2] = 0;
	piece[4][0][3][2] = 0;
	piece[4][1][3][2] = 0;
	piece[4][2][3][2] = 0;
	piece[4][3][3][2] = 0;

	piece[4][0][0][3] = 0;
	piece[4][1][0][3] = 0;
	piece[4][2][0][3] = 1;
	piece[4][3][0][3] = 0;
	piece[4][0][1][3] = 1;
	piece[4][1][1][3] = 1;
	piece[4][2][1][3] = 1;
	piece[4][3][1][3] = 0;
	piece[4][0][2][3] = 0;
	piece[4][1][2][3] = 0;
	piece[4][2][2][3] = 0;
	piece[4][3][2][3] = 0;
	piece[4][0][3][3] = 0;
	piece[4][1][3][3] = 0;
	piece[4][2][3][3] = 0;
	piece[4][3][3][3] = 0;



	//Piece 6

	piece[5][0][0][0] = 0;
	piece[5][1][0][0] = 1;
	piece[5][2][0][0] = 1;
	piece[5][3][0][0] = 0;
	piece[5][0][1][0] = 0;
	piece[5][1][1][0] = 1;
	piece[5][2][1][0] = 0;
	piece[5][3][1][0] = 0;
	piece[5][0][2][0] = 0;
	piece[5][1][2][0] = 1;
	piece[5][2][2][0] = 0;
	piece[5][3][2][0] = 0;
	piece[5][0][3][0] = 0;
	piece[5][1][3][0] = 0;
	piece[5][2][3][0] = 0;
	piece[5][3][3][0] = 0;

	piece[5][0][0][1] = 1;
	piece[5][1][0][1] = 0;
	piece[5][2][0][1] = 0;
	piece[5][3][0][1] = 0;
	piece[5][0][1][1] = 1;
	piece[5][1][1][1] = 1;
	piece[5][2][1][1] = 1;
	piece[5][3][1][1] = 0;
	piece[5][0][2][1] = 0;
	piece[5][1][2][1] = 0;
	piece[5][2][2][1] = 0;
	piece[5][3][2][1] = 0;
	piece[5][0][3][1] = 0;
	piece[5][1][3][1] = 0;
	piece[5][2][3][1] = 0;
	piece[5][3][3][1] = 0;

	piece[5][0][0][2] = 0;
	piece[5][1][0][2] = 1;
	piece[5][2][0][2] = 0;
	piece[5][3][0][2] = 0;
	piece[5][0][1][2] = 0;
	piece[5][1][1][2] = 1;
	piece[5][2][1][2] = 0;
	piece[5][3][1][2] = 0;
	piece[5][0][2][2] = 1;
	piece[5][1][2][2] = 1;
	piece[5][2][2][2] = 0;
	piece[5][3][2][2] = 0;
	piece[5][0][3][2] = 0;
	piece[5][1][3][2] = 0;
	piece[5][2][3][2] = 0;
	piece[5][3][3][2] = 0;

	piece[5][0][0][3] = 0;
	piece[5][1][0][3] = 0;
	piece[5][2][0][3] = 0;
	piece[5][3][0][3] = 0;
	piece[5][0][1][3] = 1;
	piece[5][1][1][3] = 1;
	piece[5][2][1][3] = 1;
	piece[5][3][1][3] = 0;
	piece[5][0][2][3] = 0;
	piece[5][1][2][3] = 0;
	piece[5][2][2][3] = 1;
	piece[5][3][2][3] = 0;
	piece[5][0][3][3] = 0;
	piece[5][1][3][3] = 0;
	piece[5][2][3][3] = 0;
	piece[5][3][3][3] = 0;




	//Piece 7! The one I forgot about.

	piece[6][0][0][0] = 0;
	piece[6][1][0][0] = 1;
	piece[6][2][0][0] = 0;
	piece[6][3][0][0] = 0;
	piece[6][0][1][0] = 1;
	piece[6][1][1][0] = 1;
	piece[6][2][1][0] = 1;
	piece[6][3][1][0] = 0;
	piece[6][0][2][0] = 0;
	piece[6][1][2][0] = 0;
	piece[6][2][2][0] = 0;
	piece[6][3][2][0] = 0;
	piece[6][0][3][0] = 0;
	piece[6][1][3][0] = 0;
	piece[6][2][3][0] = 0;
	piece[6][3][3][0] = 0;

	piece[6][0][0][1] = 0;
	piece[6][1][0][1] = 1;
	piece[6][2][0][1] = 0;
	piece[6][3][0][1] = 0;
	piece[6][0][1][1] = 1;
	piece[6][1][1][1] = 1;
	piece[6][2][1][1] = 0;
	piece[6][3][1][1] = 0;
	piece[6][0][2][1] = 0;
	piece[6][1][2][1] = 1;
	piece[6][2][2][1] = 0;
	piece[6][3][2][1] = 0;
	piece[6][0][3][1] = 0;
	piece[6][1][3][1] = 0;
	piece[6][2][3][1] = 0;
	piece[6][3][3][1] = 0;

	piece[6][0][0][2] = 0;
	piece[6][1][0][2] = 0;
	piece[6][2][0][2] = 0;
	piece[6][3][0][2] = 0;
	piece[6][0][1][2] = 1;
	piece[6][1][1][2] = 1;
	piece[6][2][1][2] = 1;
	piece[6][3][1][2] = 0;
	piece[6][0][2][2] = 0;
	piece[6][1][2][2] = 1;
	piece[6][2][2][2] = 0;
	piece[6][3][2][2] = 0;
	piece[6][0][3][2] = 0;
	piece[6][1][3][2] = 0;
	piece[6][2][3][2] = 0;
	piece[6][3][3][2] = 0;

	piece[6][0][0][3] = 0;
	piece[6][1][0][3] = 1;
	piece[6][2][0][3] = 0;
	piece[6][3][0][3] = 0;
	piece[6][0][1][3] = 0;
	piece[6][1][1][3] = 1;
	piece[6][2][1][3] = 1;
	piece[6][3][1][3] = 0;
	piece[6][0][2][3] = 0;
	piece[6][1][2][3] = 1;
	piece[6][2][2][3] = 0;
	piece[6][3][2][3] = 0;
	piece[6][0][3][3] = 0;
	piece[6][1][3][3] = 0;
	piece[6][2][3][3] = 0;
	piece[6][3][3][3] = 0;



	
	//Piece Colors

	colors[0] = 0xff0000ff;
	colors[1] = 0x00ffffff;
	colors[2] = 0x00ff00ff;
	colors[3] = 0x0080ffff;
	colors[4] = 0xff00ffff;
	colors[5] = 0xffff00ff;
	colors[6] = 0xff8040ff;

	
	
}

//((1000-(200*(int)(log(level))))*1000)

